//Enigmatika.cpp


//	Evo kratak opis kako program radi
//	1. Proverava da li su prosledjeni parametri
//	2. Otvara fajl, pronalazi maksimalne vrednosti za vodoravno i uspravno
//		i prema njima dodeljuje memoriju za matricu ukrstenice (ovim je
//		obezbedjeno da izgled ukrstenice ne bude kvadrat, vec i neki poligon 
//		(npr. slika u skandinavci!!!!)
//	3. Vraca se na pocetak fajla i popunjava tu matricu
//		sa praznim mestima, crnim poljima i, ukoliko je korisnik specificirao i slovima!!!
//	4. Vrti u petlji i pravi ukrstenicu
#include <stdio.h>
#include <stdlib.h>
#include <fstream.h>
#include <memory.h>
#include <string.h>

#define CRNO_POLJE '#'
#define PRAZNO_POLJE '*'

#define CRNO_POLJE_FAJL '#'
#define PRAZNO_POLJE_FAJL '*'

#define VODORAVNO 0
#define USPRAVNO 1

int print_usage(void);
void clean(void);
int PoljeJePocetakReci(int, int, int);
int ResenaUkrstenica(void);
void StampajUkrstenicu(void);
void StampajOpis(void);
int NadjiSledeci(int);
unsigned int BrojPraznih(int, int);
unsigned int DuzinaReci(int, int);
void IzvadiRecIzMatrice(char*, int, int);
int PronadjiRecUBazi(char*, char*,char*, int);
int UporediReci(char*, char*);
void UpisiUMatricu(char*, int, int);
void NemaResenja(char*, int, int);
int MatricaOK(int);

//Glavna struktura
struct Enigmatika_Tag{
	int* Matrica; //sama ukrstenica
	int Smer; //0-vodoravno,1-uspravno
	//ovo su glavne vrednosti za velicinu matrice
	char** OpisVodoravno;
	char** OpisUspravno;
	unsigned int MaxUspravno;
	unsigned int MaxVodoravno;
};

//cuva otvorene fajlove 1.txt, 2.txt...
ifstream BazeFajl[9];
//i njihova imena
char ImenaFajlovaBaze[9][6]=
	{"1.txt","2.txt","3.txt","4.txt","5.txt","6.txt","7.txt","8.txt","9.txt"};

Enigmatika_Tag Ukrstenica;

int main(int argc, char* argv[])
{
	unsigned int i, Prolaz=0;
	char OneInputLine[200]; //buffer za prihvatanje podataka iz fajla
	ifstream Fajl;  //ulazni fajl

	if (argc==1){
		print_usage();
		return 0;
	}

	//otvara fajl
	Fajl.open(argv[1],ios::in | ios::nocreate);
	if (Fajl==NULL){
		printf("Ne mogu da otvorim %s\nProgram ce se ugasiti\n",argv[1]);
		return 0;
	}
	//prolazi prvi put kroz fajl da bi uzeo maxVodoravno i MaxUspravno promenljive
	//trazeci njihove maksimalne vrednosti
	while(!Fajl.eof()){
		Fajl.getline(OneInputLine,200,'\n');
		if (strlen(OneInputLine)!=0)
			Ukrstenica.MaxUspravno++;
		if (strlen(OneInputLine)>Ukrstenica.MaxVodoravno)
			Ukrstenica.MaxVodoravno=strlen(OneInputLine);
	}
	//ovo nestaje uskoro
	printf("MaxVodoravno:%u, MaxUspravno:%u\n",Ukrstenica.MaxVodoravno,Ukrstenica.MaxUspravno);


	//Vracanje na pocetak fajla i resetovanje eof flag-a
	Fajl.seekg(0);
	Fajl.clear();

	//sad dodeljujemo pravu duzinu ukrstenici
	Ukrstenica.Matrica=(int*)malloc(sizeof(int)*Ukrstenica.MaxVodoravno*Ukrstenica.MaxUspravno);
	Ukrstenica.OpisVodoravno=(char**)malloc(sizeof(char*)*Ukrstenica.MaxVodoravno*Ukrstenica.MaxUspravno);
	Ukrstenica.OpisUspravno= (char**)malloc(sizeof(char*)*Ukrstenica.MaxVodoravno*Ukrstenica.MaxUspravno);
	//Pounjavanje sa # cele ukstenice, ukoliko ima slike u njoj
	for (i=0;i<Ukrstenica.MaxVodoravno*Ukrstenica.MaxUspravno;i++)
		Ukrstenica.Matrica[i]='#';

	//i ponovno otvaranje
	//ovaj put za prebacivanje iz pattern fajla u matricu
	//Fajl.open(argv[1],ios::in | ios::nocreate);

	while(!Fajl.eof()){
		Fajl.getline(OneInputLine,200,'\n');
		for (i=0;i<strlen(OneInputLine);i++){
			//ukoliko je prazna kockica
			if (OneInputLine[i]==PRAZNO_POLJE_FAJL)
				Ukrstenica.Matrica[Prolaz*Ukrstenica.MaxVodoravno+i]=PRAZNO_POLJE;
			//ukoliko je tacka
			else if (OneInputLine[i]==CRNO_POLJE_FAJL)
				Ukrstenica.Matrica[Prolaz*Ukrstenica.MaxVodoravno+i]=CRNO_POLJE;
			//ukoliko je neki znak,. tj. veliko slovo
			else if ((OneInputLine[i]>=65) && (OneInputLine[i]<=90))
				Ukrstenica.Matrica[Prolaz*Ukrstenica.MaxVodoravno+i]=OneInputLine[i];
			//nepoznati karakter - to nam ne treba
			else{
				printf("Ilegalan karakter u fajlu\nProgram ce se ugasiti\n");
				Fajl.close();
				clean();
				return 0;
			}

		}
		Prolaz++;
	}
	//zatvaranje fajla
	Fajl.close();
	
	//otvara sve baze
	for (i=0;i<9;i++){
		BazeFajl[i].open(ImenaFajlovaBaze[i],ios::in | ios::nocreate);
	}

	//ovde ide sav rad
	int indexZaTrazenje, Dalje;
	int* MatricaTemp;
	char pattern[100];
	char Nadjeno[100];
	char Opis[300];
	MatricaTemp=(int*)malloc(sizeof(int)*Ukrstenica.MaxVodoravno*Ukrstenica.MaxUspravno);

	do{
		Dalje=0;
		memcpy(MatricaTemp,Ukrstenica.Matrica,sizeof(int)*Ukrstenica.MaxUspravno*Ukrstenica.MaxVodoravno);
		indexZaTrazenje=NadjiSledeci(Ukrstenica.Smer);
		IzvadiRecIzMatrice(pattern,indexZaTrazenje,Ukrstenica.Smer);
ponovo:
		Dalje=PronadjiRecUBazi(pattern,Nadjeno,Opis,Dalje);
		if (Dalje==-1){
			NemaResenja(pattern,indexZaTrazenje, Ukrstenica.Smer);
			clean();
			return 0;
		}
		UpisiUMatricu(Nadjeno,indexZaTrazenje,Ukrstenica.Smer);
		if (MatricaOK(Ukrstenica.Smer)==0){
			memcpy(Ukrstenica.Matrica,MatricaTemp,sizeof(int)*Ukrstenica.MaxUspravno*Ukrstenica.MaxVodoravno);
			goto ponovo;
		}
		if (Ukrstenica.Smer==VODORAVNO){
			Ukrstenica.OpisVodoravno[indexZaTrazenje]=(char*)malloc(sizeof(char)*strlen(Opis));
			strcpy(Ukrstenica.OpisVodoravno[indexZaTrazenje],Opis);
		}
		else if (Ukrstenica.Smer==USPRAVNO){
			Ukrstenica.OpisUspravno[indexZaTrazenje]=(char*)malloc(sizeof(char)*strlen(Opis));
			strcpy(Ukrstenica.OpisUspravno[indexZaTrazenje],Opis);
		}
		if (Ukrstenica.Smer==VODORAVNO)
			Ukrstenica.Smer=USPRAVNO;
		else
			Ukrstenica.Smer=VODORAVNO;
	} while (ResenaUkrstenica()!=1);
	//stampa ukrstenicu
	printf("Ukrstenica je resena\nSad cu je prikazati...\n\n");
	StampajUkrstenicu();
	StampajOpis();
	//poziva ciscenje svega sto je mozda jos otvoreno
	clean();
	return 0;
}

//ispisuje koriscenje programa
int print_usage(void)
{
	printf("Koriscenje programa:\nEnigmatika <input_file>\n\ninput_file je izgled (pattern) vase buduce ukrstenice\n");
	return 0;
}

//cisti sve sto se moze cistiti
void clean()
{
	unsigned int i;
	for (i=0;i<9;i++){
		if (BazeFajl[i]!=NULL)
			BazeFajl[i].close();
	}
	free(Ukrstenica.OpisVodoravno);
	free(Ukrstenica.OpisUspravno);
	free(Ukrstenica.Matrica);
	return;
}

//funkcija koja vraca 1 ukoliko je polje (x,y) polje kojim pocinje
//vodoravna/uspravna rec (tj. polje koje na pravoj ukrstenici ima broj u uglu
//za vodoravno/uspravno)
//u suprotnom vraca 0
//Promenljiva Smer sadrzi da li trazimo za vodoravno (0) ili uspravno (1)
int PoljeJePocetakReci(int x, int y, int Smer)
{
	int index; //ovo je ekvivalent (x,y) polja u matrici
	index=y*Ukrstenica.MaxVodoravno+x;

	if (Smer==VODORAVNO){
		//ukoliko je u pitanju crno polje, ono nikako ne moze biti pocetak reci
		if (Ukrstenica.Matrica[index]==CRNO_POLJE)
			return 0;

		//ukoliko je prva kolona, to je sigurno pocetak reci
		if (x==0)
			return 1;

		//ukoliko je prethodno polje crno, ovo je pocetak ukrstenice
		if (Ukrstenica.Matrica[index-1]==CRNO_POLJE)
			return 1;

		//nema vise mogucnosti, pali napolje
			return 0;
	}
	else if (Smer==USPRAVNO){
		//ukoliko je u pitanju crno polje, ono nikako ne moze biti pocetak reci
		if (Ukrstenica.Matrica[index]==CRNO_POLJE)
			return 0;

		//ukoliko je prvi red, to je sigurno pocetak reci
		if (y==0)
			return 1;

		//ukoliko je polje iznad crno, ovo je pocetak ukrstenice
		if (Ukrstenica.Matrica[index-Ukrstenica.MaxVodoravno]==CRNO_POLJE)
			return 1;

		//nema vise mogucnosti, pali napolje
		return 0;
	}
	return 0;
}

//vraca 1 ukoliko vise nema praznih polja, tj. ukoliko je ukrstenica resena
int ResenaUkrstenica()
{
	unsigned int i;
	for (i=0;i<Ukrstenica.MaxVodoravno*Ukrstenica.MaxUspravno;i++){
		if (Ukrstenica.Matrica[i]==PRAZNO_POLJE)
			return 0;
	}
	return 1;
}

//stampa celu ukrstenicu u konzolu
void StampajUkrstenicu()
{
	unsigned int i, j;
	//prolazi kroz celu matricu i stampa je, slovo po slovo
	for (i=0;i<Ukrstenica.MaxUspravno;i++){
		for (j=0;j<Ukrstenica.MaxVodoravno;j++){
			printf("%c",Ukrstenica.Matrica[i*Ukrstenica.MaxVodoravno+j]);
		}
		printf("\n");
	}
}

void StampajOpis()
{
	unsigned int index, x, y, i=0;
	printf("Vodoravno:\n");
	for (index=0;index<Ukrstenica.MaxVodoravno*Ukrstenica.MaxUspravno;index++){
		x=index % Ukrstenica.MaxVodoravno;
		y=(index-x)/Ukrstenica.MaxVodoravno;
		if (PoljeJePocetakReci(x,y,VODORAVNO)==1){
			printf("%i.%s\n",i++,Ukrstenica.OpisVodoravno[index]);
		}
	}
	i=0;
	printf("\nUspravno:\n");
	for (index=0;index<Ukrstenica.MaxVodoravno*Ukrstenica.MaxUspravno;index++){
		x=index % Ukrstenica.MaxVodoravno;
		y=(index-x)/Ukrstenica.MaxVodoravno;
		if (PoljeJePocetakReci(x,y,USPRAVNO)==1){
			printf("%i.%s\n",i++,Ukrstenica.OpisUspravno[index]);
		}
	}
}
int NadjiSledeci(int Smer)
{
	int i, j, index=-1,indexTrenutni;
	float ProcenatPraznih, MinProcenatPraznih=100;

	if (Smer==VODORAVNO){
		for (j=Ukrstenica.MaxUspravno-1;j>=0;j--){
			for (i=Ukrstenica.MaxVodoravno-1;i>=0;i--){
				if (PoljeJePocetakReci(i,j,Smer)==1){
					indexTrenutni=j*Ukrstenica.MaxVodoravno+i;
					ProcenatPraznih=100*(float)BrojPraznih(indexTrenutni, Smer)/(float)DuzinaReci(indexTrenutni,Smer);
					if ((MinProcenatPraznih>=ProcenatPraznih) && (ProcenatPraznih!=0)){
						MinProcenatPraznih=ProcenatPraznih;
						index=indexTrenutni;
					}
				}
			}
		}
	}
	else if (Smer==USPRAVNO){
		for (i=Ukrstenica.MaxVodoravno-1;i>=0;i--){
			for (j=Ukrstenica.MaxUspravno-1;j>=0;j--){
				if (PoljeJePocetakReci(i,j,Smer)==1){
					indexTrenutni=j*Ukrstenica.MaxVodoravno+i;
					ProcenatPraznih=100*(float)BrojPraznih(indexTrenutni, Smer)/(float)DuzinaReci(indexTrenutni,Smer);
					if ((MinProcenatPraznih>=ProcenatPraznih) && (ProcenatPraznih!=0)){
						MinProcenatPraznih=ProcenatPraznih;
						index=indexTrenutni;
					}
				}
			}
		}
	}
	return index;
}

unsigned int BrojPraznih(int index, int Smer)
{
	unsigned int i,Duzina=0;
	if (Smer==VODORAVNO){
		for (i=index;i<index+DuzinaReci(index,Smer);i++){
			if (Ukrstenica.Matrica[i]==PRAZNO_POLJE)
				Duzina++;
		}
	}
	else if (Smer==USPRAVNO){
		for (i=index;i<index+DuzinaReci(index,Smer)*Ukrstenica.MaxUspravno;i=i+Ukrstenica.MaxVodoravno){
			if (Ukrstenica.Matrica[i]==PRAZNO_POLJE)
				Duzina++;
		}
	}
	return Duzina;
}

unsigned int DuzinaReci(int index, int Smer)
{
	unsigned int i,Duzina=1;
	if (Smer==VODORAVNO){
		for (i=index+1;i<index+Ukrstenica.MaxVodoravno+1;i++){
			if (i% Ukrstenica.MaxVodoravno==0)
				return Duzina;
			if (Ukrstenica.Matrica[i]==CRNO_POLJE)
				return Duzina;
			Duzina++;
		}
	}
	else if (Smer==USPRAVNO){
		for (i=index+Ukrstenica.MaxVodoravno;i<index+Ukrstenica.MaxVodoravno*Ukrstenica.MaxUspravno;i=i+Ukrstenica.MaxVodoravno){
			if (i > Ukrstenica.MaxVodoravno*Ukrstenica.MaxUspravno)
				return Duzina;
			if (Ukrstenica.Matrica[i]==CRNO_POLJE)
				return Duzina;
			Duzina++;
		}
	}
	return Duzina;
}

void IzvadiRecIzMatrice(char* Rec,int index,int Smer)
{
	char Temp[100];
	unsigned int i, pntrTemp=0;
	if (Smer==VODORAVNO){
		for (i=0;i<DuzinaReci(index,Smer);i++){
			Temp[i]=Ukrstenica.Matrica[index+i];
		}
	}
	else if (Smer==USPRAVNO){
		for (i=index;i<index+DuzinaReci(index,Smer)*Ukrstenica.MaxUspravno;i=i+Ukrstenica.MaxVodoravno){
			Temp[pntrTemp]=Ukrstenica.Matrica[i];
			pntrTemp++;
		}
	}
	Temp[DuzinaReci(index,Smer)]='\0';
	strcpy(Rec,Temp);
	return;
}

int PronadjiRecUBazi(char* pattern,char* Nadjeno,char* Opis,int Odakle)
{
	int DuzinaPatterna;
	char OneInputLine[200];
	char RecUFajlu[200];

	DuzinaPatterna=strlen(pattern);

	BazeFajl[DuzinaPatterna-1].seekg(Odakle);
	BazeFajl[DuzinaPatterna-1].clear();
next:
	while(!BazeFajl[DuzinaPatterna-1].eof()){
		BazeFajl[DuzinaPatterna-1].getline(OneInputLine,200,'\n');
		if (strlen(OneInputLine)==0)
			goto next;
		strcpy(RecUFajlu,OneInputLine);
		RecUFajlu[strchr(RecUFajlu,';')-RecUFajlu]='\0';
		if (UporediReci(pattern,RecUFajlu)==1){
			strcpy(Nadjeno,RecUFajlu);
			strcpy(Opis,strchr(OneInputLine,';')+sizeof(char));
			return BazeFajl[DuzinaPatterna-1].tellg();
		}
	}
	return -1;
}

int UporediReci(char* pattern,char* RecIzFajla)
{
	unsigned int i;
	for (i=0;i<strlen(pattern);i++){
		if ((pattern[i]!=RecIzFajla[i]) && (pattern[i]!=PRAZNO_POLJE)){
			return 0;
		}
	}
	return 1;
}

void UpisiUMatricu(char* RecZaUpis,int index,int Smer)
{
	unsigned int i,pntrTemp=0;

	if (Smer==VODORAVNO){
		for (i=0;i<strlen(RecZaUpis);i++){
			Ukrstenica.Matrica[index+i]=RecZaUpis[i];
		}
	}
	else if (Smer==USPRAVNO){
		for (i=index;i<index+DuzinaReci(index,Smer)*Ukrstenica.MaxUspravno;i=i+Ukrstenica.MaxVodoravno){
			Ukrstenica.Matrica[i]=RecZaUpis[pntrTemp];
			pntrTemp++;
		}
	}
	return;
}

void NemaResenja(char* ZeznutaRec, int index, int Smer)
{
	int x,y;

	x=index % Ukrstenica.MaxVodoravno;
	y=(index-x)/Ukrstenica.MaxVodoravno;

	printf("Nazalost, ukrstenica ne moze da se resi. Ovo je jos probna verzija programa.\n");
	printf("Pokusajte sa manjom ukrstenicom ili sacekajte novu verziju programa\n");
	printf("Prikazacu dokle sam uspeo da resim...\n\n");
	StampajUkrstenicu();
	printf("\nRec koju ne mogu da nadjem u bazi je: %s na mestu (%i,%i) ",ZeznutaRec,x+1,y+1);
	if (Smer==VODORAVNO)
		printf("vodoravno\n");
	else if (Smer==USPRAVNO)
		printf("uspravno\n");
	return;
}

int MatricaOK(int Smer)
{
	//prvo gledamo vodoravno
	unsigned int i, j;
	char Rec[100];
	char Rec2[100];
	char Opis[300];
	if (Smer==VODORAVNO)
		Smer=USPRAVNO;
	else if (Smer==USPRAVNO)
		Smer=VODORAVNO;

	for (i=0;i<Ukrstenica.MaxVodoravno;i++){
		for (j=0;j<Ukrstenica.MaxUspravno;j++){
			if ((PoljeJePocetakReci(i,j,Smer)==1) && (BrojPraznih(j*Ukrstenica.MaxVodoravno+i,Smer)==0)){
				IzvadiRecIzMatrice(Rec,j*Ukrstenica.MaxVodoravno+i,Smer);
				if (PronadjiRecUBazi(Rec,Rec2,Opis,0)==-1)
					return 0;
				else{
					if (Smer==VODORAVNO){
						Ukrstenica.OpisVodoravno[j*Ukrstenica.MaxVodoravno+i]=(char*)malloc(sizeof(char)*strlen(Opis));
						strcpy(Ukrstenica.OpisVodoravno[j*Ukrstenica.MaxVodoravno+i],Opis);
					}
					else if (Smer==USPRAVNO){
						Ukrstenica.OpisUspravno[j*Ukrstenica.MaxVodoravno+i]=(char*)malloc(sizeof(char)*strlen(Opis));
						strcpy(Ukrstenica.OpisUspravno[j*Ukrstenica.MaxVodoravno+i],Opis);
					}
				}
			}
		}
	}
	return 1;
}